
#include "Graph.h"
#include "common.h"
#include <memory.h>		//	memsetԼ   ߰
#include "MyStack.h"

/*	׷ ʱȭϴ Լ Ű  .	*/
void GraphInit(Graph* pGraph, int VertextCount)
{
	int i;

	pGraph->NumOfEdge = 0;
	pGraph->NumOfVertex = VertextCount;

	pGraph->pVertexList = (Vertex**)malloc(sizeof(Vertex) * pGraph->NumOfVertex);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
		pGraph->pVertexList[i] = NULL;

	/*	InDegree 迭 ʱȭ	*/
	pGraph->InDegree = (int*)malloc(sizeof(int) * VertextCount);
	memset(pGraph->InDegree, 0, sizeof(int) * VertextCount);
}

/*	׷  Orign  Dest ߰ϴ Լ	*/
void AddVertex(Graph* pGraph, int Orign, int Dest, int Cost)
{
	/*	߰  Dest .	*/
	Vertex* newVertex = (Vertex*)malloc(sizeof(Vertex));
	newVertex->Dest = Dest;
	newVertex->pNext = NULL;
	newVertex->Cost = Cost;		//	 ߰

	Vertex* pCurVertex = NULL;

	/*	 Orign  Dest ߰ϴ κ	*/
	if (pGraph->pVertexList[Orign] == NULL)
		pGraph->pVertexList[Orign] = newVertex;
	else
	{
		pCurVertex = pGraph->pVertexList[Orign];

		while (pCurVertex->pNext != NULL)	
			pCurVertex = pCurVertex->pNext;

		pCurVertex->pNext = newVertex;
	}
}

/*	׷  ߰ϴ Լ,  Orign  Dest Ѵ.	*/
void AddEdge(Graph* pGraph, int Orign, int Dest, int Cost)
{
	pGraph->NumOfEdge++;

	/*	 Orign Dest 	*/
	AddVertex(pGraph, Orign, Dest, Cost);

	/*	 Ŀ  ׷̴.	*/
	/*	 Dest Orign 	*/
	//	AddVertex(pGraph, Dest, Orign, Cost);
}

/*	׷   Ѵ Լ	*/
void DisplayEdgeInfo(Graph* pGraph)
{
	int i;
	Vertex* pCurVertex = NULL;

	printf("   =>\t%d\n\n", pGraph->NumOfEdge);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		if (pGraph->pVertexList[i] == NULL)
			continue;

		printf("%c  =>\t", 'A' + i);

		pCurVertex = pGraph->pVertexList[i];

		while (pCurVertex != NULL)
		{
			printf("%c %d\t", 'A' + pCurVertex->Dest, pCurVertex->Cost);
			pCurVertex = pCurVertex->pNext;
		}
		printf("\n");
	}
}

/*	     ϴ Լ	*/
void RemoveAllVertex(Vertex* pHead)
{
	Vertex* pCurVertex = NULL;
	Vertex* pDelVertex = NULL;

	if (pHead == NULL)
		return;

	pCurVertex = pHead;

	while (pCurVertex != NULL)
	{
		pDelVertex = pCurVertex;
		pCurVertex = pCurVertex->pNext;
		
		free(pDelVertex);
	}
}

/*	׷   ϴ Լ	*/
void DestroyGraph(Graph* pGraph)
{
	int i;

	if (pGraph == NULL)	
		return;
	
	/*	
		pGraph NULL ƴϸ,  Ͱ ִٴ ǹ̸, 
		pGraphȿ ִ pVertexList͸  Ѵ	
	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		/*	NULL̸, ʿǷ,  ̵Ѵ.	*/
		if (pGraph->pVertexList[i] == NULL)
			continue;	

		/*	     	*/
		RemoveAllVertex(pGraph->pVertexList[i]);

		pGraph->pVertexList[i] = NULL;
	}

	/*	    ʱȭ	*/
	pGraph->NumOfEdge = pGraph->NumOfVertex = 0;

	/*	Ҵ 		*/
	if (pGraph->InDegree != NULL)
		free(pGraph->InDegree);

	pGraph->InDegree = NULL;
}

/*	  Լ	*/
void TopologicalSort(Graph* pGraph)
{
	MyStack s;
	int i;
	int Wvertex, Uvertex;
	MyStackInit(&s);
	Vertex* pCurVertex = NULL;

	/*	1.     	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		pCurVertex = pGraph->pVertexList[i];

		while (pCurVertex != NULL)
		{
			pGraph->InDegree[pCurVertex->Dest] += 1;
			pCurVertex = pCurVertex->pNext;
		}
	}
	/*	2.   0  ÿ 	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		if (pGraph->InDegree[i] == 0)
			Push(&s, i);
	}
	/*	3.   	*/
	while (!Empty(&s))
	{
		Wvertex = Top(&s);
		Pop(&s);

		/*	 	*/
		printf("%c ", Wvertex + 'A');

		pCurVertex = pGraph->pVertexList[Wvertex];

		//	    Ѵ.
		while (pCurVertex != NULL)
		{
			Uvertex = pCurVertex->Dest;

			//	  Ѵ.
			pGraph->InDegree[Uvertex] -= 1;

			/*	  0  ÿ 	*/
			if (pGraph->InDegree[Uvertex] == 0)
				Push(&s, Uvertex);

			//	  ̵.
			pCurVertex = pCurVertex->pNext;
		}
	}
	/*	 .	*/
	while (!Empty(&s))
		Pop(&s);
}

